<?php require_once('altauth_lib.php');

class ClickBank {
    private $PRODUCTS_LIST_URL = 'https://api.clickbank.com/rest/1.3/products/list?site=';
    private $RECEIPTS_PATH;
    private $cb;
    
    public function __construct() {
        $this->cb = load_clickbank();
        $this->RECEIPTS_PATH = realpath(dirname(__FILE__) . '/uploads/receipts');
    }
    
    public function loadProductListBySiteName() {
        $products = array();
        
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $this->PRODUCTS_LIST_URL . $this->cb['cb_site_name']);
        curl_setopt($ch, CURLOPT_HEADER, 0); 
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array("Accept: application/json", "Authorization: " . $this->cb['cb_dev_api_key'] . ":" . $this->cb['cb_clerk_api_key']));
        $result = curl_exec($ch);
        curl_close($ch);

        $decodedResult = json_decode($result, true);

        foreach($decodedResult['products']['product'] as $product)
            array_push($products, $product);
        
        return $products;
    }
    
    public function saveReceipt($receiptId, $items) {
        $fh = fopen($this->RECEIPTS_PATH . '/receipt' . $receiptId . '.rcp', 'w');
        fwrite($fh, json_encode($items));
        fclose($fh);
    }
    
    public function checkReceipt($receiptId, $product) {
        $file = $this->RECEIPTS_PATH . '/receipt' . $receiptId . '.rcp';
        
        if(!file_exists($file))
            return false;
            
        $fh = fopen($file, 'r');
        $encodedProduct = chop(fgets($fh));
        fclose($fh);
        
        $decoded = json_decode($encodedProduct, true);
        
        return $decoded[0]['itemNo'] === $product;
    }
}
