<?php
include_once('ViewManager.php');

class Controller {
    private $uploadDir; 
    private $view; 
    
    public function __construct() {
        $this->uploadDir = realpath(dirname(__FILE__) . '/../uploads') . '/';
        $this->view = new ViewManager();
    }
    
    public function __destruct() {
        unset($this->view);
    }
    
    public function loadVideo($id, $needMd5 = true) {
        $md5Id = ($needMd5) ? md5($id) : $id;
        
        if(file_exists($this->uploadDir . $md5Id)) {
            $fh = fopen($this->uploadDir . $md5Id, "r+");
        
            $serialized = fgets($fh);

            fclose($fh);

            return unserialize($serialized);
        }
        
        return null;
    }
    
    public function loadVideos() {
        $videos = array();
        $files = array_diff(scandir($this->uploadDir), array('.', '..', 'receipts'));
        
        foreach($files as $file) {
            $ext = pathinfo($file, PATHINFO_EXTENSION);
        
            if($ext == null)
                array_push($videos, $this->loadVideo($file, false));
        }
    
        return $videos;
    }
    
    public function hasVideo($id) {
        $md5Id = md5($id);
        return file_exists($this->uploadDir . $md5Id);
    }
    
    public function saveVideo($post) {
        $md5Id = md5($post['yt_id']);
        if(count($post['serialized_layer']) > 0)
            foreach($post['serialized_layer'] as $key => $layer) {
                if($layer == null)
                    unset($post['overlay_type'][$key]);
            }
        
        if(count($post['custom_html']) > 0)
            foreach($post['custom_html'] as $key => $html) {
                $post['custom_html'][$key] = str_replace(array("\r\n", "\n", "\r"), '', $html);
            }
        
        unset($post['iframe_width']);
        unset($post['iframe_height']);
        unset($post['iframe_code']);
        
        $serializedVideo = serialize($post);
        $fh = fopen($this->uploadDir . $md5Id, "w+") or die(__('fail_cannot_write')." $this->uploadDir . $md5Id ".__('fail_cannot_write_2'));
        
        fwrite($fh, $serializedVideo);
        fclose($fh);
    }
    
    public function deleteVideo($id) {
        $md5Id = md5($id);
        
        if(file_exists($this->uploadDir . $md5Id))
            unlink($this->uploadDir . $md5Id);
    }
    
    public function renderTemplate($name, $params) {
        $this->view->renderPage($name . '_form', array('values' => $params));
    }
    
    public function renderEmbedPage($id) {
        $video = $this->loadVideo($id, false);
        $this->view->renderPage('embed_page', array('video' => $video));
    }
}