<?php

class UrlManager {
    private $urls = array(
        'logout' => array('slug' => 'logout', 'raw' => 'altauth.php?do_logout'),
        'dashboard' => array('slug' => 'dashboard', 'raw' => 'altauth_admin.php'),
        'admin' => array('slug' => 'admin', 'raw' => 'altauth_loginscreen.php'),
        'settings' => array('slug' => 'settings', 'raw' => 'altauth_admin_settings.php'),
        'user_settings' => array('slug' => 'user_settings', 'raw' => 'altauth_admin_user_settings.php'),
        'videos' => array('slug' => 'videos', 'raw' => 'altauth_admin.php')
    );
    
    public function getUrl($theUrl) {
        if(!array_key_exists($theUrl, $this->urls))
                return;
        
        $dirname = dirname($_SERVER['PHP_SELF']);
        $dirname = ($dirname == DIRECTORY_SEPARATOR) ? '' : $dirname;
        return $dirname . '/' . $this->urls[$theUrl]['raw'];
    }
    
    public function getTemplatesPath($extraPath = '') {
        return realpath(dirname(__FILE__) . '/templates/' . $extraPath);
    }
    
    public function buildCompleteUrl($s) {
        $ssl      = ( ! empty( $s['HTTPS'] ) && $s['HTTPS'] == 'on' );
        $sp       = strtolower( $s['SERVER_PROTOCOL'] );
        $protocol = substr( $sp, 0, strpos( $sp, '/' ) ) . ( ( $ssl ) ? 's' : '' );
        $port     = $s['SERVER_PORT'];
        $port     = ( ( ! $ssl && $port=='80' ) || ( $ssl && $port=='443' ) ) ? '' : ':'.$port;
        $host     = ( $use_forwarded_host && isset( $s['HTTP_X_FORWARDED_HOST'] ) ) ? $s['HTTP_X_FORWARDED_HOST'] : ( isset( $s['HTTP_HOST'] ) ? $s['HTTP_HOST'] : null );
        $host     = isset( $host ) ? $host : $s['SERVER_NAME'] . $port;
        return $protocol . '://' . $host;
    }
    
    public function getUrlWithoutScript($s) {
        $completeUrl = $this->buildCompleteUrl($s) . $s['REQUEST_URI'];
        $completeUrl = explode('/', htmlspecialchars($completeUrl, ENT_QUOTES, 'UTF-8'));
        array_pop($completeUrl);
        
        return implode('/', $completeUrl);
    }
}