/*
 * This simple method is used to inherit the prototype, the constructor and the attributes
 * from a superclass.
 * 
 */
Object.defineProperty(Object.prototype, "inherit", {
    "enumerable": false,
    "value": function (constructor) {
        this.prototype = Object.create(constructor.prototype);
        this.prototype.constructor = this;
    }
});

window.TVE = window.TVE || {};

window.TVE = (function () {
    var timeInterval = null;

    /* --------- UTILS --------- */
    var Utils = (function () {
        var INSTANCE;
        return {
            /* Singleton in JavaScript */
            getInstance: function () {
                if (INSTANCE == null)
                    INSTANCE = {
                        getDomain: function (url) {
                            var TLDs = ["ac", "ad", "ae", "aero", "af", "ag", "ai", "al", "am", "an", "ao", "aq", "ar", "arpa", "as", "asia", "at", "au", "aw", "ax", "az", "ba", "bb", "bd", "be", "bf", "bg", "bh", "bi", "biz", "bj", "bm", "bn", "bo", "br", "bs", "bt", "bv", "bw", "by", "bz", "ca", "cat", "cc", "cd", "cf", "cg", "ch", "ci", "ck", "cl", "cm", "cn", "co", "com", "coop", "cr", "cu", "cv", "cx", "cy", "cz", "de", "dj", "dk", "dm", "do", "dz", "ec", "edu", "ee", "eg", "er", "es", "et", "eu", "fi", "fj", "fk", "fm", "fo", "fr", "ga", "gb", "gd", "ge", "gf", "gg", "gh", "gi", "gl", "gm", "gn", "gov", "gp", "gq", "gr", "gs", "gt", "gu", "gw", "gy", "hk", "hm", "hn", "hr", "ht", "hu", "id", "ie", "il", "im", "in", "info", "int", "io", "iq", "ir", "is", "it", "je", "jm", "jo", "jobs", "jp", "ke", "kg", "kh", "ki", "km", "kn", "kp", "kr", "kw", "ky", "kz", "la", "lb", "lc", "li", "lk", "lr", "ls", "lt", "lu", "lv", "ly", "ma", "mc", "md", "me", "mg", "mh", "mil", "mk", "ml", "mm", "mn", "mo", "mobi", "mp", "mq", "mr", "ms", "mt", "mu", "museum", "mv", "mw", "mx", "my", "mz", "na", "name", "nc", "ne", "net", "nf", "ng", "ni", "nl", "no", "np", "nr", "nu", "nz", "om", "org", "pa", "pe", "pf", "pg", "ph", "pk", "pl", "pm", "pn", "pr", "pro", "ps", "pt", "pw", "py", "qa", "re", "ro", "rs", "ru", "rw", "sa", "sb", "sc", "sd", "se", "sg", "sh", "si", "sj", "sk", "sl", "sm", "sn", "so", "sr", "st", "su", "sv", "sy", "sz", "tc", "td", "tel", "tf", "tg", "th", "tj", "tk", "tl", "tm", "tn", "to", "tp", "tr", "travel", "tt", "tv", "tw", "tz", "ua", "ug", "uk", "us", "uy", "uz", "va", "vc", "ve", "vg", "vi", "vn", "vu", "wf", "ws", "xn--0zwm56d", "xn--11b5bs3a9aj6g", "xn--3e0b707e", "xn--45brj9c", "xn--80akhbyknj4f", "xn--90a3ac", "xn--9t4b11yi5a", "xn--clchc0ea0b2g2a9gcd", "xn--deba0ad", "xn--fiqs8s", "xn--fiqz9s", "xn--fpcrj9c3d", "xn--fzc2c9e2c", "xn--g6w251d", "xn--gecrj9c", "xn--h2brj9c", "xn--hgbk6aj7f53bba", "xn--hlcj6aya9esc7a", "xn--j6w193g", "xn--jxalpdlp", "xn--kgbechtv", "xn--kprw13d", "xn--kpry57d", "xn--lgbbat1ad8j", "xn--mgbaam7a8h", "xn--mgbayh7gpa", "xn--mgbbh1a71e", "xn--mgbc0a9azcg", "xn--mgberp4a5d4ar", "xn--o3cw4h", "xn--ogbpf8fl", "xn--p1ai", "xn--pgbs0dh", "xn--s9brj9c", "xn--wgbh1c", "xn--wgbl6a", "xn--xkc2al3hye2a", "xn--xkc2dl3a5ee0h", "xn--yfro4i67o", "xn--ygbi2ammx", "xn--zckzah", "xxx", "ye", "yt", "za", "zm", "zw"].join();

                            var parts = url.split('.');

                            if (parts[0] === 'www' && parts[1] !== 'com')
                                parts.shift();

                            var ln = parts.length, i = ln, minLength = parts[parts.length - 1].length, part;

                            while (part = parts[--i]) {
                                if (i === 0
                                        || i < ln - 2
                                        || part.length < minLength
                                        || TLDs.indexOf(part) < 0
                                        ) {
                                    return part;
                                }
                            }
                        },
                        parseLinkWithAnchor: function(href) {
                            var location = document.createElement("a");
                            location.href = href;
                            
                            return location;
                        },
                        getAdapterName: function (href) {
                            var location = this.parseLinkWithAnchor(href);

                            if (location.host == '')
                                location.href = location.href;

                            var domainName = this.getDomain(location.hostname);
                            return this.capitalizeString(domainName);
                        },
                        getYouTubeIdFromUrl: function (url) {
                            var regExp = /^.*((youtu.be\/)|(v\/)|(\/u\/\w\/)|(embed\/)|(watch\?))\??v?=?([^#\&\?]*).*/;
                            var match = url.match(regExp);
                            return (match && match[7].length == 11) ? match[7] : false;
                        },
                        removeElement: function (element) {
                            if ($(element).length > 0)
                                $(element).remove();
                        },
                        checkAndAddClass: function (element, className) {
                            if (!$(element).hasClass(className))
                                $(element).addClass(className);
                        },
                        capitalizeString: function (string) {
                            return (string !== undefined) ? string.charAt(0).toUpperCase() + string.slice(1) : null;
                        },
                        unserialize: function (data) {
                            return $.phpUnserialize(data);
                        },
                        unserializeAndParse: function (string) {
                            var obj = this.unserialize(atob(string));
                            eval('obj = $.extend(new ' + obj.layerName + '(), obj);');
                            return obj;
                        }
                    };
                return INSTANCE;
            }
        };
    })();

    /* --------- EXPOSED FUNCTIONS --------- */
    var init = function (videoObjects) {
        $.each(videoObjects, function (i, val) {
            var url = $(val).attr('src');

            var adapterName = Utils.getInstance().getAdapterName(url);
            VideoFactory.getInstance().make(adapterName, val);
        });
    };

    var genericOverlayHandler = function (type, videoObject, eventData) {        
        var adapter = null;
        eval('adapter = ' + type + 'Adapter.getInstance();');
        var time = adapter.getCurrentTime(eventData);
        var status = adapter.getStatus(eventData);
        
        $(videoObject.getDomElement()).parent().find('[data-lyt]').trigger('crvez', [time, status]);
        clearInterval(timeInterval);

        timeInterval = setInterval(function () {
            time = adapter.getCurrentTime(eventData);
            status = adapter.getStatus(eventData);

            $(videoObject.getDomElement()).parent().find('[data-lyt]').trigger('crvez', [time, status]);
        }, 500);
    };

    /* --------- DOMAIN --------- */
    function Video(id, width, height, domElement, overlay) {
        this.id = id;
        this.width = width;
        this.height = height;
        this.apiObject = null;
        this.domElement = domElement;
        this.overlay = overlay;

        var context = this;

        this.play = function () {};

        this.pause = function () {};

        this.getId = function () {
            return this.id;
        };

        this.setApiObject = function (apiObject) {
            this.apiObject = apiObject;
        };

        this.getDomElement = function () {
            return this.domElement;
        };

        this.getOverlay = function () {
            return this.overlay;
        };

        $(window).resize(function () {
            context.width = $(context.domElement).width();
            context.height = $(context.domElement).height();

            context.overlay.adjustSize(context.width, context.height);
        });

        this.overlay.setVideo(this);
    }
    /* We define generic global states, each specific state is then converted in one of those states */
    Video.states = {
        unstarted: -1,
        ended: 0,
        playing: 1,
        paused: 2,
        buffering: 3,
        cued: 5
    };

    function YoutubeVideo(id, width, height, domElement, overlay, autoplay) {
        Video.call(this, id, width, height, domElement, overlay, autoplay);

        this.play = function () {
            this.apiObject.playVideo();
        };

        this.pause = function () {
            this.apiObject.pauseVideo();
        };
    }

    YoutubeVideo.inherit(Video);

    var Overlay = function (id, width, height, domElement) {
        this.id = id;
        this.width = width;
        this.height = height;
        this.domElement = domElement;
        this.video = null;
        this.layers = [];
        var overlayObserver = new OverlayObserver(this);
        var currentLayer = null;
        var context = this;

        this.adjustSize = function (width, height) {
            this.width = width;
            this.height = height;

            $(this.domElement).css('width', this.width + 'px');
            $(this.domElement).css('height', this.height + 'px');
        };

        this.showOverlay = function () {
            $(this.domElement).fadeIn();
        };

        this.hideOverlay = function () {
            $(this.domElement).fadeOut();
        };

        this.handleVisibility = function (isShown) {
            if (isShown)
                this.showOverlay();
            else
                this.hideOverlay();
        };

        this.setLayerProperties = function (layerObject) {
            var overlayDomElement = $(this.domElement).find('.overlay');
            layerObject.setOverlay(this);
            layerObject.setDomElement(overlayDomElement);
            layerObject.setUpListener();
            return layerObject;
        };

        this.addLayer = function (layerObject) {
            this.setLayerProperties(layerObject);
            this.layers.push(layerObject);
        };

        this.loadLayers = function () {
            if(typeof window.serializedLayers != 'undefined' && window.serializedLayers != '') {
                var unserializedLayers = Utils.getInstance().unserialize(window.serializedLayers);
                $.each(unserializedLayers, function(i, val) {
                    if(val != '') {
                        var layerObject = Utils.getInstance().unserializeAndParse(val);
                        context.addLayer(layerObject);
                    }
                });
            }
        };

        this.setLayersDomElement = function () {
            var overlayDomElement = $(this.domElement).find('.overlay');

            $.each(this.layers, function (i, val) {
                val.setDomElement(overlayDomElement);
            });
        };
        
        this.setListeners = function() {
            $.each(this.layers, function (i, val) {
                val.removeListener();
                val.setUpListener();
            });
        };

        this.getWidth = function () {
            return this.width;
        };

        this.getHeight = function () {
            return this.height;
        };

        this.getDomElement = function () {
            return this.domElement;
        };

        this.setVideo = function (video) {
            this.video = video;
        };

        this.getVideo = function () {
            return this.video;
        };

        this.getLayers = function () {
            return this.layers;
        };

        this.setCurrentLayer = function (layer) {
            currentLayer = layer;
        };

        this.getCurrentLayer = function () {
            return currentLayer;
        };

        this.adjustSize(this.width, this.height);
        this.hideOverlay();

        overlayObserver.init();

        this.loadLayers();
    };

    /* Strategy GoF Pattern to handle different behaviors on each Layer */
    function Layer(content, time, duration, overlay, domElement, needPause) {
        /* Workaround for unserializing, to know which Layer subclass we're creating! :) */
        this.layerName = this.constructor.name;
        this.content = content;
        this.time = parseInt(time);
        this.duration = parseInt(duration);
        this.overlay = overlay;
        this.domElement = domElement;
        this.needPause = needPause;
        this.isShowing = false;

        var eventCatcher = null;
        var context = this;

        /* Workaround to get the custom event in the object, we create a div, append it and bind the event.
         * crvez is "time_update", obfuscated :P */
        this.setUpListener = function () {
            eventCatcher = document.createElement('div');
            var d = new Date();
            $(eventCatcher).attr('data-lyt', d.getTime() + d.getMilliseconds());
            $(eventCatcher).insertAfter(this.domElement);
            $(eventCatcher).bind('crvez', function (e, time, status) {
                context.checkLayer(time, status);
            });
        };

        this.removeListener = function () {
            $(eventCatcher).attr('data-removing', '1');
            $(eventCatcher).remove();
        };

        this.checkLayer = function (currentTime, status) {
            if (this.isShowing) {
                if (currentTime < this.time || currentTime > this.time + this.duration) {
                    this.setIsShowing(false);
                    if (this.overlay.getCurrentLayer() === this)
                        this.overlay.handleVisibility(this.getIsShowing());
                }

                return;
            }

            if ((currentTime >= this.time && currentTime <= this.time + this.duration) && !this.isShowing) {
                this.overlay.setCurrentLayer(this);

                this.setIsShowing(true);
                this.overlay.handleVisibility(this.isShowing);
                $(this.domElement).empty().append(this.content);

                if (this.needPause)
                    this.overlay.getVideo().pause();

                this.handleBehavior(currentTime);
            }
        };

        this.getOverlay = function () {
            return this.overlay;
        };

        this.setOverlay = function (overlay) {
            this.overlay = overlay;
        };

        this.setDomElement = function (domElement) {
            this.domElement = domElement;
        };

        this.getIsShowing = function () {
            return this.isShowing;
        };

        this.setIsShowing = function (isShowing) {
            this.isShowing = isShowing;
        };

        this.handleBehavior = function () {};
        this.onLayerHide = function() {
            $(this.domElement).empty();
        };

        this.hideAndPlay = function () {
            this.overlay.hideOverlay();
            if (this.needPause)
                this.overlay.getVideo().play();

            this.onLayerHide();
        };
    }

    /* This layer prints a content and wait for the click to disappear, or 
     * if the time + duration is passed.
     */
    function DefaultLayer(content, time, duration, overlay, domElement, needPause, clickSelector) {
        Layer.call(this, content, time, duration, overlay, domElement, needPause);
        this.clickSelector = clickSelector;

        var context = this;

        this.handleBehavior = function () {
            if (typeof this.clickSelector !== 'undefined')
                $(context.domElement).off('click', this.clickSelector).on('click', this.clickSelector, function () {
                    var href = $(this).attr('data-href');
                    if(href !== undefined) {
                        var urlTrick = document.createElement('a');
                        urlTrick.href = href;
                        urlTrick.target = '_blank';
                        document.body.appendChild(urlTrick);
                        urlTrick.click(); 
                        $(urlTrick).remove();
                    }
                    
                    context.hideAndPlay();
                });
        };
    }

    DefaultLayer.inherit(Layer);

    /* This layer opens popups for each data-popup object and has a callback function
     * to handle different behaviors of closing. popupData has width and height of the popup.
     */
    function PopupLayer(content, time, duration, overlay, domElement, needPause, popupData, callback) {
        Layer.call(this, content, time, duration, overlay, domElement, needPause);
        this.popupData = popupData;
        this.callbackAttributeFn = callback;

        var context = this;

        this.handleBehavior = function () {
            var popUps = $(this.domElement).find('[data-popup]');
            
            $(popUps).on('click', function (e) {
                e.preventDefault();

                var strParam = 'width=' + context.popupData.width + ',height=' + context.popupData.height + ',scrollbars=' + context.popupData.scrollbars + ',resizable=' + context.popupData.resizable;
                var objWindow = window.open($(this).attr('href'), 'Popup', strParam);
                objWindow.focus();

                context.handlePopupClosing(objWindow);

                return false;
            });
        };
        
        this.handlePopupClosing = function(objWindow) {
            var pollTimer = setInterval(function () {
                context.callbackAttributeFn(objWindow, context, pollTimer);
            }, 500);
        };
    }

    PopupLayer.inherit(Layer);

    /* This layer prints an iframe and loads a custom HTML in it, parsing it in head and body tags.
     * needPosition is used to check if put a padding surrounding the iframe, needCloseTrigger is used to
     * check when close the iframe, setting a data-closed="1" attribute.
     */
    function FramedLayer(content, time, duration, overlay, domElement, needPause, needPosition, needCloseTrigger) {
        var html = (needPosition) ? '<div class="position">' : '';
        html += '<iframe data-html-iframe ';
        html += (needPosition) ? 'class="not-absolute" ' : '';
        html += 'src="about:blank" frameborder="0"></iframe>';
        html += (needPosition) ? '</div>' : '';

        Layer.call(this, html, time, duration, overlay, domElement, needPause);
        this.needCloseTrigger = needCloseTrigger;
        this.frameContent = content;

        var context = this;

        this.handleBehavior = function () {
            var ifr = $(context.domElement).find('[data-html-iframe]').get(0);
            var ifrWindow = ifr.contentWindow;

            $(ifrWindow).on('load', function() {
                if(this.document.readyState == 'complete')
                    context.onIFrameLoad(ifrWindow.document);
            });

            $(ifrWindow).trigger('load');
        };

        this.onIFrameLoad = function(ifrDocument) {
            var parsed = context.parseContent();
            var preparedDocument = context.prepareDocument(ifrDocument, parsed);
            /* We reinit the listener because it's removed from frame jQuery o.O */
            context.removeListener();
            context.setUpListener();

            if(this.needCloseTrigger)
                var pollTimer = setInterval(function () {
                    if ($(preparedDocument).find('body').attr('data-closed') !== undefined) {
                        clearInterval(pollTimer);

                        context.hideAndPlay();
                    }
                }, 200);
        };

        this.parseContent = function () {
            var $dom = $(document.createElement('html'));
            $dom.get(0).innerHTML = this.frameContent; /* Here's where the "magic" happens! */
            var $head = $($dom).find('head');
            var $body = $($dom).find('body');
            
            var head = ($head.html() !== '') ? $head : undefined;
            var body = $body;

            return {head: head, body: body};
        };

        this.prepareDocument = function (ifrDocument, content) {
            var $head = $('head', ifrDocument);
            var $body = $('body', ifrDocument);

            if (content.head === undefined) {
                $head.append('<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" />');
                $head.append('<style>body { background: transparent; color: #fff }</style>');
            } else
                $head.replaceWith(content.head);

            $head.append('<base target="_blank" />');

            $body.replaceWith(content.body);

            return ifrDocument;
        };
    }

    FramedLayer.inherit(Layer);

    /* This layer prints a canvas and load a special PNG video into it using CreateJS. */
    function EffectLayer(content, time, duration, overlay, domElement, needPause, effectDuration, skipAfterTimer) {
        Layer.call(this, content, time, duration, overlay, domElement, needPause);
        this.effectDuration = effectDuration;
        this.skipAfterTimer = skipAfterTimer;

        /* Canvas and CreateJS fields */
        this.effectUrl = null;
        this.effectName = null;
        this.effectCanvas = null;
        this.exportRoot = null;
        this.stage = null;
        this.timer = 0;

        var context = this;

        this.handleBehavior = function () {
            this.effectCanvas = $(this.domElement).find('#effect-canvas').get(0);
            
            $.getScript($(this.effectCanvas).prev().attr('data-src'), this.prepareCanvas.bind(undefined, this));
        };

        this.prepareCanvas = function(context, data, textStatus, jqxhr) {
            context.effectUrl = context.getEffectUrl();
            context.effectName = context.getEffectName(context.effectUrl);
            
            context.initCanvas();

            context.timer = setTimeout(function() {
                context.hideAndPlay();
            }, context.effectDuration * 1000);

            $(window).resize(function() {
                context.setCanvasSize();
            });
        };
        
        this.initCanvas = function() {
            var loader = new createjs.LoadQueue(false);
            createjs.Sound.alternateExtensions = ["mp3"];
            loader.installPlugin(createjs.Sound);
            loader.addEventListener("fileload", this.handleFileLoad);
            loader.addEventListener("complete", this.handleComplete);
            loader.loadFile({
                src: this.effectUrl + '_atlas_.json', 
                type: 'spritesheet', 
                id: this.effectName + '_atlas_'
            }, true);
            loader.loadManifest(window.lib.properties.manifest);
        };

        this.handleFileLoad = function(evt) {
            if(evt.item.type == "image")
                window.images[evt.item.id] = evt.result; 
        };

        this.handleComplete = function(evt) {
            $(context.domElement).find('.video-loader').remove();
            
            if(context.skipAfterTimer > 0) {
                setTimeout(function() {
                    var skipEffect = $(context.domElement).find('.skip-effect');
                    skipEffect.css('display', 'block');
                    var skipLink = skipEffect.find('[data-skip]').get(0);
                    $(skipLink).on('click', function() {
                       context.hideAndPlay();
                       clearTimeout(context.timer);
                    });

                }, context.skipAfterTimer * 1000);
            }
            
            var queue = evt.target;
            window.ss[context.effectName + '_atlas_'] = queue.getResult(context.effectName + '_atlas_');
            eval('context.exportRoot = new window.lib.' + context.effectName + '();');
          
            context.setCanvasSize();
            context.stage = new createjs.Stage(context.effectCanvas);
            context.stage.addChild(context.exportRoot);
            context.stage.update();

            createjs.Ticker.setFPS(window.lib.properties.fps);
            createjs.Ticker.addEventListener("tick", context.stage);
        };

        this.setCanvasDimensions = function() {
            var width = this.overlay.getWidth();
            var height = this.overlay.getHeight();
            
            $(this.effectCanvas).attr('width', width);
            $(this.effectCanvas).attr('height', height);
        };
        
        this.setCanvasScale = function() {
            var width = this.overlay.getWidth();
            var height = this.overlay.getHeight();
            
            context.exportRoot.scaleX = (width / 800) * 1; 
            context.exportRoot.scaleY = (height / 450) * 1;
        };
        
        this.setCanvasSize = function() {
            this.setCanvasDimensions();
            this.setCanvasScale();
        };
        
        this.getEffectUrl = function() {
            var effectUrl = $(this.effectCanvas).prev().attr('data-src');
            effectUrl = effectUrl.substring(0, effectUrl.length - 3);
            
            return effectUrl;
        };
        
        this.getEffectName = function(effectUrl) {
            var effectName = effectUrl.split('/');
            effectName = effectName.pop();
            
            return effectName;
        };
        
        this.onLayerHide = function() {
            $(this.domElement).empty();
            
            createjs.Ticker.reset();
            context.stage.enableDOMEvents(false);
            createjs.Sound.stop();
        };
    }

    EffectLayer.inherit(Layer);

    /* This Layer uses the status in checkLayer, also the check to make is passed through a variable so it's
     * not static.
     */
    function SpecialLayer(content, duration, overlay, domElement, check) {
        Layer.call(this, content, -1, duration, overlay, domElement, true);
        this.check = check;
        
        this.checkLayer = function (currentTime, status) {
            if (this.isShowing)
                return;
            
            var test = false;
            eval('test = (' + this.check + ');');
            
            if (test) {
                this.overlay.setCurrentLayer(this);

                this.setIsShowing(true);
                this.overlay.handleVisibility(this.isShowing);
                $(this.domElement).empty().append(this.content);
                
                this.handleBehavior(currentTime);
            }
        };
    }
    
    /* Specific for Start Screen Layer, when the user starts a video and time is 0, we display this
     * layer and after a time we hide it.
     */
    function StartScreenLayer(content, duration, overlay, domElement, check) {
        SpecialLayer.call(this, content, duration, overlay, domElement, check);

        var context = this;

        this.handleBehavior = function () {
            this.overlay.getVideo().pause();
            
            setTimeout(function () {
                context.hideAndPlay();
                setTimeout(function () { context.setIsShowing(false); }, (context.duration + 2) * 1000);
            }, this.duration * 1000);
        };
    }

    StartScreenLayer.inherit(SpecialLayer);
    
    /* Specific for Start Screen Layer, when the video ends, we display this
     * layer and after a time we hide it.
     */
    function EndScreenLayer(content, duration, overlay, domElement, check) {
        SpecialLayer.call(this, content, duration, overlay, domElement, check);

        var context = this;

        this.handleBehavior = function () {
            setTimeout(function () {
                context.overlay.hideOverlay();
            }, this.duration * 1000);
        };
    }

    EndScreenLayer.inherit(SpecialLayer);   
    
    /* Before starting the video, we display this layer and when the user clicks it we hide the layer and
     * start the video. 
     */
    function CustomThumbnailLayer(content, overlay, domElement, check) {
        SpecialLayer.call(this, content, -1, overlay, domElement, check);

        var context = this;

        this.handleBehavior = function () {
            $(this.domElement).find('[data-thumb-click]').on('click', null, function() {
                context.hideAndPlay();
            });
        };
    }

    CustomThumbnailLayer.inherit(SpecialLayer);

    /* Factory GoF Pattern to get the Adapter Singleton dynamically for each iframe */
    var VideoFactory = (function () {
        var INSTANCE;
        return {
            /* Singleton in JavaScript */
            getInstance: function () {
                if (INSTANCE == null)
                    INSTANCE = {
                        make: function (name, object) {
                            var adapterName = name + 'Adapter';
                            var adapter = null;

                            eval("if(typeof " + adapterName + " !== 'undefined') adapter = " + adapterName + ".getInstance();");

                            return (!adapter) ? null : adapter.createVideoObject(object);
                        }
                    };

                return INSTANCE;
            }
        };
    })();

    /* Adapter GoF Pattern to support future integrations with other websites */
    var YoutubeAdapter = (function () {
        var INSTANCE;
        return {
            /* Singleton in JavaScript */
            getInstance: function () {
                if (INSTANCE == null)
                    INSTANCE = {
                        states: {
                            '-1': Video.states.unstarted,
                            '0': Video.states.ended,
                            '1': Video.states.playing,
                            '2': Video.states.paused,
                            '3': Video.states.buffering,
                            '5': Video.states.cued
                        },
                        createVideoObject: function (object) {
                            var url = $(object).attr('src');
                            var videoObject = null;
                            
                            /* We need to be 100% sure that YT is ready to start the framework */
                            var ytReadyTimer = setInterval(function() {
                                if(typeof YT !== 'undefined') {
                                    if(YT.loaded) {
                                        clearInterval(ytReadyTimer);
                                        
                                        if (url.match(/^(https?:\/\/)?([^\/]*\.)?youtube\.com(.*)/i)) {
                                            var width = $(object).width();
                                            var height = $(object).height();
                                            var videoId = Utils.getInstance().getYouTubeIdFromUrl(url);
                                            var overlayDomElement = $(object).parent().find('.overlay-wrapper');

                                            var overlay = new Overlay(videoId, width, height, overlayDomElement);
                                            videoObject = new YoutubeVideo(videoId, width, height, object, overlay);

                                            var player = new YT.Player(object);

                                            player.addEventListener('onReady', genericOverlayHandler.bind(undefined, 'Youtube', videoObject));
                                            player.addEventListener('onStateChange', genericOverlayHandler.bind(undefined, 'Youtube', videoObject));

                                            videoObject.setApiObject(player);
                                        }
                                    }
                                }
                            }, 200);

                            return videoObject;
                        },
                        getCurrentTime: function (apiObject) {
                            return apiObject.target.getCurrentTime();
                        },
                        getStatus: function (apiObject) {
                            return (apiObject.data == null) ? this.states['-1'] : this.states[apiObject.data + ''];
                        }
                    };

                return INSTANCE;
            }
        };
    })();

    var OverlayObserver = function (overlay) {
        this.overlay = overlay;
        this.mutationObserver = null;

        this.init = function () {
            var context = this;
            var domOverlayWrapper = this.overlay.getDomElement();
            var embedWrapper = $(domOverlayWrapper).parent();

            if (embedWrapper.length <= 0)
                return;

            this.mutationObserver = new MutationObserver(function (e) {
                var typeName = Utils.getInstance().capitalizeString(e[0].type);
                typeName += 'ObserverChecker';

                var observerChecker = null;
                eval("if(typeof " + typeName + " !== 'undefined') observerChecker = new " + typeName + "(context.overlay);");
                if (observerChecker)
                    observerChecker.observe(e, domOverlayWrapper, embedWrapper);
            });

            this.mutationObserver.observe(embedWrapper.get(0), {childList: true, subtree: true, attributes: true});
        };
    };

    /* Polymorphism GRASP Pattern to handle different behaviors for the ObserverChecker */
    function ObserverChecker(overlay) {
        this.overlay = overlay;

        this.observe = function (e, domOverlayWrapper, embedWrapper) {};
    }

    function ChildListObserverChecker(overlay) {
        ObserverChecker.call(this, overlay);

        this.observe = function (e, domOverlayWrapper, embedWrapper) {
            if (e[0].removedNodes.length <= 0)
                return;

            var $overlayWrapper = embedWrapper.find('.overlay-wrapper');
            var removedNode = $(e[0].removedNodes[0]);

            if (removedNode.is('div.overlay'))
                Utils.getInstance().removeElement($overlayWrapper);
            else if(removedNode.is('div[data-lyt]')) {
                if(removedNode.attr('data-removing') === undefined)
                    $(this.overlay.getDomElement()).append(removedNode);
            } else if (!removedNode.is('div.overlay-wrapper'))
                Utils.getInstance().removeElement($overlayWrapper);

            if ($overlayWrapper.length <= 0) {
                embedWrapper.append(domOverlayWrapper);

                Utils.getInstance().checkAndAddClass(domOverlayWrapper, 'overlay-wrapper');

                if ($(domOverlayWrapper).find('.overlay').length == 0) {
                    $(domOverlayWrapper).append('<div class="overlay"></div>');
                    this.overlay.setLayersDomElement();
                    this.overlay.setListeners();
                }

                var layer = this.overlay.getCurrentLayer();
                if (layer)
                    layer.setIsShowing(false);

                this.overlay.adjustSize(this.overlay.getWidth(), this.overlay.getHeight());
            }
        };
    }

    ChildListObserverChecker.inherit(ObserverChecker);

    function AttributesObserverChecker(overlay) {
        ObserverChecker.call(this, overlay);

        this.observe = function (e, domOverlayWrapper, embedWrapper) {
            if (e[0].attributeName !== 'class' && e[0].attributeName !== 'style' && e[0].attributeName !== 'data-lyt')
                return;

            var $overlayWrapper = $(embedWrapper).find('.overlay-wrapper');

            switch (e[0].attributeName) {
                case 'class':
                    var $overlay = $(embedWrapper).find('.overlay');

                    if ($overlayWrapper.length <= 0)
                        Utils.getInstance().checkAndAddClass(e[0].target, 'overlay-wrapper');

                    if ($overlay.length <= 0)
                        Utils.getInstance().checkAndAddClass(e[0].target, 'overlay');
                    break;
                case 'style':
                    if (!$overlayWrapper.attr('style')) {
                        this.overlay.adjustSize(this.overlay.getWidth(), this.overlay.getHeight());

                        var layer = this.overlay.getCurrentLayer();
                        if (layer)
                            this.overlay.handleVisibility(layer.getIsShowing());
                        else
                            this.overlay.hideOverlay();
                    }
                    break;
                case 'data-lyt':
                    if($(e[0].target).attr('data-lyt') === undefined) {
                        var d = new Date();
                        $(e[0].target).attr('data-lyt', d.getTime() + d.getMilliseconds());
                    }
                break;
            }
        };
    }

    AttributesObserverChecker.inherit(ObserverChecker);

    return {
        init: init
    };
})();

function initTVE() {
    var videoObjects = $('iframe');

    if (videoObjects.length > 0)
        TVE.init(videoObjects);
}

$(document).ready(function() {
    initTVE();
});