<?php require_once(dirname(__FILE__) . '/../../altauth_language.php') ?>
<?php $id = str_replace('.', '', uniqid('', true)) ?>
<?php $values = $params['values'] ?>

<div class="alert alert-success" role="alert" style="display: none"><?php echo __('layer_loaded') ?></div>

<input type="hidden" name="overlay_type[<?php echo $id ?>]" value="customHtml" />
<input type="hidden" name="serialized_layer[<?php echo $id ?>]" value="" />

<div class="form-group">
    <div class="col-sm-10 col-sm-offset-2">
        <textarea id="<?php echo $id ?>" data-override-hidden name="custom_html[<?php echo $id ?>]" data-error="<?php echo __('required_field'); ?>" required class="tinymce-box form-control"><?php echo $values['custom_html']; ?></textarea>
        <span class="help-block has-error" style="display: none"></span>
    </div>
</div>

<div class="form-group">
    <label class="control-label col-sm-2" for="start_at[<?php echo $id ?>]"><?php echo __('start_at'); ?>:</label>
    <div class="col-sm-10">
        <div class="row">
            <div class="col-sm-10">
                <input type="text" class="form-control" data-validate="number,lesser" data-lesser-field="stop_at[<?php echo $id ?>]" data-error="<?php echo __('required_field'); ?>" data-number-error="<?php echo __('invalid_number'); ?>" data-lesser-error="<?php echo __('invalid_less_than_stop'); ?>" id="start_at[<?php echo $id ?>]" name="start_at[<?php echo $id ?>]" placeholder="<?php echo __('start_at'); ?>" required value="<?php echo $values['start_at']; ?>">
                <span class="help-block has-error" style="display: none"></span>
            </div>
            <div class="col-sm-2">
                <select name="start_at_type[<?php echo $id ?>]" class="form-control">
                    <option value="sec" <?php if($values['start_at_type'] === 'sec') echo 'selected' ?>><?php echo __('seconds'); ?></option>
                    <option value="min" <?php if($values['start_at_type'] === 'min') echo 'selected' ?>><?php echo __('minutes'); ?></option>
                </select>
            </div>
        </div>
    </div>
</div>

<div class="form-group" data-stop-at="<?php echo $id ?>">
    <label class="control-label col-sm-2" for="stop_at[<?php echo $id ?>]"><?php echo __('stop_at'); ?>:</label>
    <div class="col-sm-10">
        <div class="row">
            <div class="col-sm-10">
                <input type="text" class="form-control" data-validate="number,greater" data-greater-field="start_at[<?php echo $id ?>]" data-error="<?php echo __('required_field'); ?>" data-number-error="<?php echo __('invalid_number'); ?>" data-greater-error="<?php echo __('invalid_greater_than_start'); ?>" id="stop_at[<?php echo $id ?>]" name="stop_at[<?php echo $id ?>]" placeholder="<?php echo __('stop_at'); ?>" required value="<?php echo $values['stop_at']; ?>">
                <span class="help-block has-error" style="display: none"></span>
            </div>
            <div class="col-sm-2">
                <select name="stop_at_type[<?php echo $id ?>]" class="form-control">
                    <option value="sec" <?php if($values['stop_at_type'] === 'sec') echo 'selected' ?>><?php echo __('seconds'); ?></option>
                    <option value="min" <?php if($values['stop_at_type'] === 'min') echo 'selected' ?>><?php echo __('minutes'); ?></option>
                </select>
            </div>
        </div>
    </div>
</div>

<div class="form-group"> 
    <div class="col-sm-6">
        <a href="#!" class="remove-overlay" data-remove-id="<?php echo $id ?>"><?php echo __('remove_overlay') ?></a>
    </div>
    
    <div class="col-sm-6 text-right">
        <button type="button" class="btn btn-info" data-remove="" data-overlay-id="<?php echo $id ?>" data-edit="<?php echo __('edit') ?>"><?php echo __('insert'); ?></button>
    </div>
</div>

<?php if($values['activate_mce'] !== 'edit') : ?>
    <script>
        tinymce.init({
            height: 300,
            selector: "#<?php echo $id ?>", 
            extended_valid_elements: "script[charset|defer|language|src|type]",
            menubar: "edit insert format table tools", 
            toolbar: 'fontselect fontsizeselect forecolor backcolor | styleselect | bold italic | alignleft aligncenter alignright alignjustify | bullist numlist outdent indent | link image media table | preview code fullpage | undo redo',
            plugins: [
                'advlist autolink link image lists charmap print preview hr anchor pagebreak spellchecker',
                'searchreplace wordcount visualblocks visualchars code fullscreen insertdatetime media nonbreaking',
                'save table contextmenu directionality template paste textcolor'
            ],
            content_css: "https://maxcdn.bootstrapcdn.com/bootstrap/3.3.6/css/bootstrap.min.css",
            resize: false
        });    
    </script>
<?php endif ?>