<?php require_once(dirname(__FILE__) . '/../../altauth_language.php') ?>
<?php require_once(dirname(__FILE__) . '/../../altauth_lib.php') ?>
<?php $id = str_replace('.', '', uniqid('', true)) ?>
<?php $values = $params['values'] ?>

<div class="alert alert-success" role="alert" style="display: none"><?php echo __('layer_loaded') ?></div>

<input type="hidden" name="overlay_type[<?php echo $id ?>]" value="effect" />
<input type="hidden" name="serialized_layer[<?php echo $id ?>]" value="" />

<input type="hidden" name="skip_text[<?php echo $id ?>]" value="<?php echo __('skip_effect') ?>" />
<div class="form-group">
    <label class="control-label col-sm-2" for="effect_name[<?php echo $id ?>]"><?php echo __('select_effect'); ?>:</label>
    <div class="col-sm-10">
        <?php $files = array_diff(scandir(realpath(dirname(__FILE__) . '/effects')), array('.', '..', 'sounds')); ?>
        <select name="effect_name[<?php echo $id ?>]" class="form-control">
            <?php foreach ($files as $i => $file) { ?>
                <?php $ext = pathinfo($file, PATHINFO_EXTENSION);

                      if($ext == 'json') {
                        $theName = str_replace('_atlas_.json', '', $file);
                        $displayName = str_replace('_', ' ', $theName) ?>
                        <option value="<?php echo $theName ?>" <?php if ($values['effect_name'] === $theName) echo 'selected' ?>><?php echo $displayName ?></option>
                      <?php } ?>
            <?php } ?>
        </select>
    </div>
</div>

<div class="form-group">
    <label class="control-label col-sm-2" for="start_at[<?php echo $id ?>]"><?php echo __('start_at'); ?>:</label>
    <div class="col-sm-10">
        <div class="row">
            <div class="col-sm-10">
                <input type="text" class="form-control" data-validate="number" data-error="<?php echo __('required_field'); ?>" data-number-error="<?php echo __('invalid_number'); ?>" id="start_at[<?php echo $id ?>]" name="start_at[<?php echo $id ?>]" placeholder="<?php echo __('start_at'); ?>" required value="<?php echo $values['start_at']; ?>">
                <span class="help-block has-error" style="display: none"></span>
            </div>
            <div class="col-sm-2">
                <select name="start_at_type[<?php echo $id ?>]" class="form-control">
                    <option value="sec" <?php if ($values['start_at_type'] === 'sec') echo 'selected' ?>><?php echo __('seconds'); ?></option>
                    <option value="min" <?php if ($values['start_at_type'] === 'min') echo 'selected' ?>><?php echo __('minutes'); ?></option>
                </select>
            </div>
        </div>
    </div>
</div>

<div class="form-group">
    <label class="control-label col-sm-2" for="duration[<?php echo $id ?>]"><?php echo __('duration'); ?>:</label>
    <div class="col-sm-10">
        <div class="row">
            <div class="col-sm-10">
                <input type="text" class="form-control" data-validate="number" data-error="<?php echo __('required_field'); ?>" data-number-error="<?php echo __('invalid_number'); ?>" id="duration[<?php echo $id ?>]" name="duration[<?php echo $id ?>]" placeholder="<?php echo __('duration'); ?>" required value="<?php echo $values['duration']; ?>">
                <span class="help-block has-error" style="display: none"></span>
            </div>
            <div class="col-sm-2">
                <select name="duration_type[<?php echo $id ?>]" class="form-control">
                    <option value="sec" <?php if($values['duration_type'] === 'sec') echo 'selected' ?>><?php echo __('seconds'); ?></option>
                    <option value="min" <?php if($values['duration_type'] === 'min') echo 'selected' ?>><?php echo __('minutes'); ?></option>
                </select>
            </div>
        </div>
    </div>
</div>

<div class="form-group">
    <label class="control-label col-sm-2" for="pause_video[<?php echo $id ?>]"><?php echo __('pause_video_effect'); ?>:</label>
    <div class="col-sm-10">
        <input type="checkbox" <?php if($values['pause_video'] == 1) echo 'checked' ?> id="pause_video[<?php echo $id ?>]" name="pause_video[<?php echo $id ?>]" value="1" />
    </div>
</div>

<div class="form-group">
    <label class="control-label col-sm-2" for="skip_effect[<?php echo $id ?>]"><?php echo __('skip_effect'); ?>?</label>
    <div class="col-sm-10">
        <input type="checkbox" <?php if($values['skip_effect'] == 1) echo 'checked' ?> id="skip_effect[<?php echo $id ?>]" name="skip_effect[<?php echo $id ?>]" data-need-skip="<?php echo $id ?>" value="1" />
    </div>
</div>

<div class="form-group" data-skip-at="<?php echo $id ?>" <?php if($values['skip_effect'] == 1) echo 'style="display: block"'; else echo 'style="display: none"' ?>>
    <label class="control-label col-sm-2" for="skip_effect_at[<?php echo $id ?>]"><?php echo __('skip_effect_at'); ?>:</label>
    <div class="col-sm-10">
        <div class="row">
            <div class="col-sm-10">
                <input type="text" class="form-control" data-validate="number,lesser" data-lesser-field="duration[<?php echo $id ?>]" data-error="<?php echo __('required_field'); ?>" data-number-error="<?php echo __('invalid_number'); ?>" data-lesser-error="<?php echo __('invalid_lesser_than_duration'); ?>" id="skip_effect_at[<?php echo $id ?>]" name="skip_effect_at[<?php echo $id ?>]" placeholder="<?php echo __('skip_effect_at'); ?>" required value="<?php echo $values['skip_effect_at']; ?>">
                <span class="help-block has-error" style="display: none"></span>
            </div>
            <div class="col-sm-2">
                <select name="skip_effect_at_type[<?php echo $id ?>]" class="form-control">
                    <option value="sec" <?php if($values['skip_effect_at_type'] === 'sec') echo 'selected' ?>><?php echo __('seconds'); ?></option>
                    <option value="min" <?php if($values['skip_effect_at_type'] === 'min') echo 'selected' ?>><?php echo __('minutes'); ?></option>
                </select>
            </div>
        </div>
    </div>
</div>

<div class="form-group"> 
    <div class="col-sm-6">
        <a href="#!" class="remove-overlay" data-remove-id="<?php echo $id ?>"><?php echo __('remove_overlay') ?></a>
    </div>

    <div class="col-sm-6 text-right">
        <button type="button" class="btn btn-info" data-remove="" data-overlay-id="<?php echo $id ?>" data-edit="<?php echo __('edit') ?>"><?php echo __('insert'); ?></button>
    </div>
</div>