<?php require_once(dirname(__FILE__) . '/../../altauth_language.php') ?>
<?php require_once(dirname(__FILE__) . '/../../altauth_lib.php') ?>
<?php require_once(dirname(__FILE__) . '/../../ClickBank.php') ?>
<?php $id = str_replace('.', '', uniqid('', true)) ?>
<?php $values = $params['values'] ?>
<?php $isJVZooEnabled = is_registration_method_enabled('jvzoo') ?>
<?php $isCBEnabled = is_registration_method_enabled('clickbank') ?>

<?php if ($isJVZooEnabled || $isCBEnabled) : ?>
    <?php 
        if($isJVZooEnabled)
            $jvzoo = load_jvzoo();
        
        if($isCBEnabled)
            $cb = load_clickbank();
        
        if(count($jvzoo) <= 0 && $cb['clickbank_key'] == null) : 
            $isJVZooEnabled = false;
            $isCBEnabled = false ?> 
            <div class="form-group">
                <div class="col-sm-12">
                    <?php echo __('jvzoo_cb_keys_null') ?>
                </div>
            </div>
        <?php else : ?> 
            <?php
                $services = array();
                if($isJVZooEnabled && count($jvzoo) > 0)
                    $services['jvzoo'] = 1;

                if($isCBEnabled && $cb['clickbank_key'] != null)
                    $services['clickbank'] = 2;
            ?>
            
            <div class="alert alert-success" role="alert" style="display: none"><?php echo __('layer_loaded') ?></div>

            <input type="hidden" name="overlay_type[<?php echo $id ?>]" value="sellingUrl" />
            <input type="hidden" name="serialized_layer[<?php echo $id ?>]" value="" />


            <div class="form-group">
                <label class="control-label col-sm-2" for="sale_service[<?php echo $id ?>]"><?php echo __('sale_service'); ?>:</label>
                <div class="col-sm-10">
                    <select name="sale_service[<?php echo $id ?>]" data-activate-hidden class="form-control">
                        <?php foreach ($services as $serviceName => $serviceId) : ?>
                            <option value="<?php echo $serviceName ?>" <?php if($values['sale_service'] === $serviceName) echo 'selected' ?> data-hidden-value="<?php echo $serviceId ?>"><?php echo __($serviceName) ?></option>
                        <?php endforeach; ?>
                    </select>
                </div>
            </div>

            <?php $firstId = 0;
                foreach($services as $key) {
                    $firstId = $key;
                    break;
                } ?>

            <?php 
            if($isJVZooEnabled) { ?>
                <div class="form-group" data-hidden="1" <?php if($values['sale_service'] === 'jvzoo' || ($firstId == 1 && $values['sale_service'] !== 'clickbank')) echo 'style="display: block"' ?>>
                    <label class="control-label col-sm-2" for="jvzoo_product_link[<?php echo $id ?>]"><?php echo __('jvzoo_product_link'); ?>:</label>
                    <div class="col-sm-10">
                        <input type="text" class="form-control" required data-validate="url,regexp" data-error="<?php echo __('required_field'); ?>" data-regexp="(https?:\/\/)?(?:www\.)?jvzoo\.com\/c\/(\d+)?\/\d+" data-regexp-error="<?php echo __('invalid_jvzoo_product'); ?>" data-url-error="<?php echo __('invalid_url'); ?>" id="jvzoo_product_link[<?php echo $id ?>]" name="jvzoo_product_link[<?php echo $id ?>]" placeholder="<?php echo __('jvzoo_product_link'); ?>" value="<?php echo $values['jvzoo_product_link']; ?>">
                        <span class="help-block has-error" style="display: none"></span>
                    </div>
                </div>

                <div class="form-group" data-hidden="1" <?php if($values['sale_service'] === 'jvzoo' || ($firstId == 1 && $values['sale_service'] !== 'clickbank')) echo 'style="display: block"' ?>>
                    <label class="control-label col-sm-2" for="jvzoo_product_banner[<?php echo $id ?>]"><?php echo __('jvzoo_product_banner'); ?>:</label>
                    <div class="col-sm-10">
                        <input type="text" class="form-control" required data-validate="url" data-error="<?php echo __('required_field'); ?>" data-url-error="<?php echo __('invalid_url'); ?>" id="jvzoo_product_banner[<?php echo $id ?>]" name="jvzoo_product_banner[<?php echo $id ?>]" placeholder="<?php echo __('jvzoo_product_banner'); ?>" value="<?php echo $values['jvzoo_product_banner']; ?>">
                        <span class="help-block has-error" style="display: none"></span>
                    </div>
                </div>
            <?php } ?>

            <?php 
                if($isCBEnabled) {
                    $cb = new ClickBank();
                    $cbProducts = $cb->loadProductListBySiteName();
                    unset($cb) ?>
                    <input type="hidden" name="cb_site_uid[<?php echo $id ?>]" value="<?php echo $cb['cb_site_name'] ?>" />
                    <div class="form-group" data-hidden="2" <?php if($firstId == 2 || $values['sale_service'] === 'clickbank') echo 'style="display: block"' ?>>
                        <label class="control-label col-sm-2" for="clickbank_products[<?php echo $id ?>]"><?php echo __('clickbank_products'); ?>:</label>
                        <div class="col-sm-10">
                            <?php if(count($cbProducts) > 0) : ?>
                                <select name="clickbank_products[<?php echo $id ?>]" class="form-control" required>
                                    <?php foreach ($cbProducts as $product) : ?>
                                        <?php if($product['status'] === 'ACTIVE') : ?>
                                            <option <?php if($values['clickbank_products'] === $product['@sku']) echo 'selected' ?> value="<?php echo $product['@sku'] ?>"><?php echo $product['title'] ?></option>
                                        <?php endif ?>
                                    <?php endforeach; ?>
                                </select>
                            <?php else : ?>
                                <select name="clickbank_products[<?php echo $id ?>]" class="form-control" required>
                                    <option value=""><?php echo __('no_cb_products'); ?></option>
                                </select>
                            <?php endif ?>
                        </div>
                    </div>
            <?php } ?>

            <input type="hidden" id="enter_transaction_text[<?php echo $id ?>]" name="enter_transaction_text[<?php echo $id ?>]" value="<?php echo __('enter_transaction_id') ?>" />
            <input type="hidden" id="check_transaction_text[<?php echo $id ?>]" name="check_transaction_text[<?php echo $id ?>]" value="<?php echo __('check_transaction') ?>" />
            <input type="hidden" id="transaction_take_text[<?php echo $id ?>]" name="transaction_take_text[<?php echo $id ?>]" value="<?php echo __('transaction_take') ?>" />

            <div class="form-group">
                <label class="control-label col-sm-2" for="start_at[<?php echo $id ?>]"><?php echo __('start_at'); ?>:</label>
                <div class="col-sm-10">
                    <div class="row">
                        <div class="col-sm-10">
                            <input type="text" class="form-control" data-validate="number" data-error="<?php echo __('required_field'); ?>" data-number-error="<?php echo __('invalid_number'); ?>" id="start_at[<?php echo $id ?>]" name="start_at[<?php echo $id ?>]" placeholder="<?php echo __('start_at'); ?>" required value="<?php echo $values['start_at']; ?>">
                            <span class="help-block has-error" style="display: none"></span>
                        </div>
                        <div class="col-sm-2">
                            <select name="start_at_type[<?php echo $id ?>]" class="form-control">
                                <option value="sec" <?php if($values['start_at_type'] === 'sec') echo 'selected' ?>><?php echo __('seconds'); ?></option>
                                <option value="min" <?php if($values['start_at_type'] === 'min') echo 'selected' ?>><?php echo __('minutes'); ?></option>
                            </select>
                        </div>
                    </div>
                </div>
            </div>

            <div class="form-group">
                <label class="control-label col-sm-2" for="v_position[<?php echo $id ?>]"><?php echo __('position'); ?>:</label>
                <div class="col-sm-10">
                    <div class="row">
                        <div class="col-sm-6">
                            <select name="v_position[<?php echo $id ?>]" class="form-control">
                                <option value="top" <?php if($values['v_position'] === 'top') echo 'selected' ?>><?php echo __('top'); ?></option>
                                <option value="middle" <?php if($values['v_position'] === 'middle') echo 'selected' ?>><?php echo __('middle'); ?></option>
                                <option value="bottom" <?php if($values['v_position'] === 'bottom') echo 'selected' ?>><?php echo __('bottom'); ?></option>
                            </select>
                        </div>
                        <div class="col-sm-6">
                            <select name="h_position[<?php echo $id ?>]" class="form-control">
                                <option value="left" <?php if($values['h_position'] === 'left') echo 'selected' ?>><?php echo __('left'); ?></option>
                                <option value="right" <?php if($values['h_position'] === 'right') echo 'selected' ?>><?php echo __('right'); ?></option>
                                <option value="center" <?php if($values['h_position'] === 'center') echo 'selected' ?>><?php echo __('center'); ?></option>
                            </select>
                        </div>
                    </div>
                </div>
            </div>

            <div class="form-group">
                <label class="control-label col-sm-2" for="product_text[<?php echo $id ?>]"><?php echo __('product_text'); ?>:</label>
                <div class="col-sm-10">
                    <input type="text" class="form-control" data-error="<?php echo __('required_field'); ?>" id="product_text[<?php echo $id ?>]" name="product_text[<?php echo $id ?>]" placeholder="<?php echo __('product_text'); ?>" required value="<?php echo $values['product_text']; ?>">
                    <span class="help-block has-error" style="display: none"></span>
                </div>
            </div>
        <?php endif ?>
<?php else : ?>
    <div class="form-group">
        <div class="col-sm-12">
    <?php echo __('jvzoo_cb_not_activated') ?>
        </div>
    </div>
<?php endif ?>
    
<div class="form-group"> 
    <div class="col-sm-6">
        <a href="#!" class="remove-overlay" data-remove-id="<?php echo $id ?>"><?php echo __('remove_overlay') ?></a>
    </div>

    <div class="col-sm-6 text-right">
        <button type="button" class="btn btn-info" data-remove="" data-overlay-id="<?php echo $id ?>" data-edit="<?php echo __('edit') ?>" <?php if (!$isJVZooEnabled && !$isCBEnabled) echo 'style="display: none"' ?>><?php echo __('insert'); ?></button>
    </div>
</div>
