<?php require_once(dirname(__FILE__) . '/../../altauth_language.php') ?>
<?php require_once(dirname(__FILE__) . '/../../altauth_lib.php') ?>
<?php $id = str_replace('.', '', uniqid('', true)) ?>
<?php $values = $params['values'] ?>
<?php $isAweberEnabled = is_registration_method_enabled('aweber') ?>

<?php if ($isAweberEnabled) : ?>
    <?php
        try {
            $aweber = load_aweber();
            $aweber_conn = new AWeberAPI($aweber['consumer_key'], $aweber['consumer_secret']);
            $account = $aweber_conn->getAccount($aweber['access_key'], $aweber['access_secret']);
            $lists = $account->lists;
        } catch (AWeberException $ex) {}
    ?>
    <?php if(count($lists) > 0) : ?>
        <div class="alert alert-success" role="alert" style="display: none"><?php echo __('layer_loaded') ?></div>

        <input type="hidden" name="overlay_type[<?php echo $id ?>]" value="subscriptionForm" />
        <input type="hidden" name="serialized_layer[<?php echo $id ?>]" value="" />

        <div class="form-group">
            <label class="control-label col-sm-2" for="template_name[<?php echo $id ?>]"><?php echo __('select_template'); ?>:</label>
            <div class="col-sm-10">
                <?php $files = array_diff(scandir(realpath(dirname(__FILE__) . '/subscription_layouts')), array('.', '..', 'css', 'images', 'js')); ?>
                <select name="template_name[<?php echo $id ?>]" class="form-control">
                    <?php foreach ($files as $i => $file) { ?>
                        <?php $theName = str_replace('.html', '', $file) ?>
                        <option value="<?php echo $theName ?>" <?php if ($values['template_name'] === $theName) echo 'selected' ?>><?php echo __('template'); ?> <?php echo $i - 4 ?></option>
                    <?php } ?>
                </select>
            </div>
        </div>
        
        <div class="form-group">
            <label class="control-label col-sm-2" for="aweber_lists[<?php echo $id ?>]"><?php echo __('select_list'); ?>:</label>
            <div class="col-sm-10">
                <select name="aweber_lists[<?php echo $id ?>]" class="form-control">
                    <?php foreach ($lists as $list) : ?>
                        <option value="<?php echo $list->id ?>" <?php if ($values['aweber_lists'] == $list->id) echo 'selected' ?>><?php echo $list->name ?></option>
                    <?php endforeach; ?>
                </select>
            </div>
        </div>  

        <div class="form-group">
            <label class="control-label col-sm-2" for="start_at[<?php echo $id ?>]"><?php echo __('start_at'); ?>:</label>
            <div class="col-sm-10">
                <div class="row">
                    <div class="col-sm-10">
                        <input type="text" class="form-control" data-validate="number" data-error="<?php echo __('required_field'); ?>" data-number-error="<?php echo __('invalid_number'); ?>" id="start_at[<?php echo $id ?>]" name="start_at[<?php echo $id ?>]" placeholder="<?php echo __('start_at'); ?>" required value="<?php echo $values['start_at']; ?>">
                        <span class="help-block has-error" style="display: none"></span>
                    </div>
                    <div class="col-sm-2">
                        <select name="start_at_type[<?php echo $id ?>]" class="form-control">
                            <option value="sec" <?php if ($values['start_at_type'] === 'sec') echo 'selected' ?>><?php echo __('seconds'); ?></option>
                            <option value="min" <?php if ($values['start_at_type'] === 'min') echo 'selected' ?>><?php echo __('minutes'); ?></option>
                        </select>
                    </div>
                </div>
            </div>
        </div>

        <div class="form-group">
            <label class="control-label col-sm-2" for="headline_msg[<?php echo $id ?>]"><?php echo __('headline_message'); ?>:</label>
            <div class="col-sm-10">
                <input type="text" class="form-control" id="headline_msg[<?php echo $id ?>]" name="headline_msg[<?php echo $id ?>]" placeholder="<?php echo __('headline_message'); ?>" value="<?php echo $values['headline_msg']; ?>">
                <span class="help-block has-error" style="display: none"></span>
            </div>
        </div>

        <div class="form-group">
            <label class="control-label col-sm-2" for="thank_you_message[<?php echo $id ?>]"><?php echo __('thank_you_message'); ?>:</label>
            <div class="col-sm-10">
                <input type="text" class="form-control" id="thank_you_message[<?php echo $id ?>]" name="thank_you_message[<?php echo $id ?>]" placeholder="<?php echo __('thank_you_message'); ?>" value="<?php echo $values['thank_you_message']; ?>">
            </div>
        </div>
    <?php else : ?>
        <div class="form-group">
            <div class="col-sm-12">
        <?php echo __('no_aweber_lists') ?>
            </div>
        </div>
    <?php endif ?>
<?php else : ?>
    <div class="form-group">
        <div class="col-sm-12">
    <?php echo __('aweber_is_not_activated') ?>
        </div>
    </div>
<?php endif ?>

<div class="form-group"> 
    <div class="col-sm-6">
        <a href="#!" class="remove-overlay" data-remove-id="<?php echo $id ?>"><?php echo __('remove_overlay') ?></a>
    </div>

    <div class="col-sm-6 text-right">
        <button type="button" class="btn btn-info" data-remove="" data-overlay-id="<?php echo $id ?>" data-edit="<?php echo __('edit') ?>" <?php if (!$isAweberEnabled) echo 'style="display: none"' ?>><?php echo __('insert'); ?></button>
    </div>
</div>