<?php

require_once('altauth_lib.php');
require_once('altauth_language.php');
require_once('YouTubeFramework/UrlManager.php');

function init()
{
        $urlManager = new UrlManager();
	$tmpl_file = "altauth_htaccess";

	# already initialized
	if (! file_exists($tmpl_file)) {
            echo __('tmpl_htaccess_not_found');
        
            return;
        }

        $path = preg_replace('/\/[^\/]+$/', '', $_SERVER['PHP_SELF']);

	// if there is no .htaccess_old then we create it
	if( ! file_exists('.htaccess_old') )
	{
		# create an empty .htpasswd unless exists
		$fh = fopen('.htpasswd', "a+")
			or die(__('fail_create_htpasswd'));
		fclose($fh);

		$fh = fopen('.htaccess_old', "w+")
			or die(__('fail_create_htaccess_old'));
	
                $htAccessPath = ($path === '') ? '' : $_SERVER[DOCUMENT_ROOT] . $path . '/';
                
		fwrite($fh,
			"AuthUserFile $htAccessPath.htpasswd\n" .
			"AuthName 'Members Only'\nAuthType Basic\nrequire valid-user\n"
		);
	
		fclose($fh);
	}

	// initialize our own .htaccess file

	$fh = fopen('.htaccess', "w+")
		or die(__('fail_create_htaccess'));
	
	foreach ( file($tmpl_file) as $line )
	{
		if($path=='')
			$line = preg_replace('/\*\/test22/', '*/', $line);
                
		$line = preg_replace('/\/test22/', $path, $line);
		fwrite($fh, $line);
	}
	
	fclose($fh);

	unlink($tmpl_file);
	
	// initialize admin user record
	
	$admin_username = 'admin';
	$admin_passwd = 'admin';
	
	save_user($admin_username, $admin_passwd);

?>
	<center><b style='color:blue'><?php echo __('protection_initialized'); ?><br><br>
	<?php echo __('init_url'); ?></b><br>
        (<?php echo __('remember_to_change')?>)
	<table>
		<tr><td><b><?php echo __('url'); ?>:</b>&nbsp;</td><td><a href="http://<?=$_SERVER['HTTP_HOST']?><?php echo $urlManager->getUrl('admin') ?>">http://<?=$_SERVER['HTTP_HOST']?><?php echo $urlManager->getUrl('admin') ?></a></td></tr>
		<tr><td><b><?php echo __('username'); ?>:</b>&nbsp;</td><td><?=$admin_username?></td></tr>
		<tr><td><b><?php echo __('password'); ?>:</b>&nbsp;</td><td><?=$admin_passwd?></td></tr>
	</table>
	</center><br><br>
<?php		
        unset($urlManager);
}

function login() 
{
	global $Message;

	$username = strtolower($_REQUEST['username']);
	$password = $_REQUEST['password'];
	
	// read passwd file
	
	foreach ( file(locate_passwd_file()) as $line )
	{
                $urlManager = new UrlManager();
		preg_match("/(.*)\:(.*)/", chop($line), $regs);
		
		if ( strcasecmp($username, $regs[1]) ) continue;
		
		$password1 = crypt($password, $regs[2]);
		$password2 = md5($password);
		$password3 = crypt_apr1_md5($password, $regs[2]);

		if ( $password1 != $regs[2] && $password2 != $regs[2] && $password3 != $regs[2] ) continue;
		
		// IP restrict
		if (iprestrict($username) && ! is_admin($username))
		{
			$Message = '<center><b>'.__('exceeded_ip').'</b></center>';	
			return;
		}
		
		// verify that the user is Active
		$userdb = load_userdb();
		if (!is_admin($username) && $userdb[$username]['status'] != 'Active') {
			$Message = '<center><b>'.__('not_authorized').'</b></center>';	
			return;			
		}

		// set cookie & session file
		$longlife = isset($_REQUEST['longlife']) ? 1 : 0;
		$uid = ($longlife ? 'longlife_' : '') . md5(uniqid(rand(),1));
		if ($longlife)
		{
			setcookie("altauth_uid", $uid, time() + 3600*24*30*3);
		}
		else
		{
			setcookie("altauth_uid", $uid);
		}
		setcookie("altauth_user", $username);
		
		$fd = fopen("_altauth/$uid", "w")
			or die(__('fail_open_session'));
		fwrite($fd, '');
		fclose($fd);
		

		if ( ! is_admin($username) ) {
			$afterLoginFile = 'altauth_afterlogin.txt';
			if(file_exists($afterLoginFile)) {
				$afterLoginURL = trim(join('', file("altauth_afterlogin.txt")));
				header("Location: ". $afterLoginURL);
			} else {
				header("Location: ". $_REQUEST['return_url']);	
			}			
		} else {
			header("Location: " . $urlManager->getUrl('dashboard'));
		}
                
                unset($urlManager);
	}
}

function logout() 
{
	$uid = $_COOKIE['altauth_uid'];
	if ($uid)
		unlink("_altauth/$uid");
	setcookie("altauth_uid", '');
	setcookie("altauth_user", '');
	
	$afterLogoutUrl = '';
	$afterLogoutFile = 'altauth_afterlogout.txt';
	
	if (file_exists($afterLogoutFile))
	{
		$afterLogoutUrl = preg_replace('/\\s+/', '', implode('', file($afterLogoutFile)));
	}
	else
	{
		$afterLogoutUrl = preg_replace('/\/[^\/]+$/', '', $_SERVER['PHP_SELF']);
		if($afterLogoutUrl == '')
			$afterLogoutUrl = '/';
                else
                    $afterLogoutUrl .= '/';
                
                $afterLogoutUrl .= 'altauth_loginscreen.php';
	}
	
        header("Location: $afterLogoutUrl");
}

function iprestrict($username)
{
	$cfg_file = 'altauth_iprestrict.txt';
	
	if ( ! file_exists($cfg_file) ) return 0;
	
	$ip_count = join('', file($cfg_file)) + 0;
	
	if ( ! $ip_count ) return 0;
	
	$username = strtolower($username);
	$remote_ip = ($_SERVER['REMOTE_ADDR'] != '::1') ? $_SERVER['REMOTE_ADDR'] : '127.0.0.1';

	$userdb = load_userdb();

	if ( ! isset($userdb[$username]) )
		$userdb[$username]['ip'] = array();
	
	if (in_array($remote_ip, $userdb[$username]['ip']))
		return 0;

	if ( $ip_count <= count($userdb[$username]['ip']))
		return 1;
	
	array_push($userdb[$username]['ip'], $remote_ip);

	if ( ! $userdb[$username]['ip'][0] )
		array_shift($userdb[$username]['ip']);

	save_userdb($userdb);
}

function cleanup_session_dir()
{
	$dh = opendir('_altauth');
	if ( ! $dh ) die(__('session_dir_corrupted'));
	
	while ( $file = readdir($dh) ) :
		if ($file == '.' || $file == '..') continue;
		$st_file = stat("_altauth/$file");
		$longlife = preg_match('/^longlife_/', $file) ? 1 : 0;
		if ( time() - $st_file[9] > 3600 * 24 * (1 + 89 * $longlife) ) unlink("_altauth/$file");
	endwhile;

	closedir($dh);
}

//---------------------------------------- M A I N --------------------------------------


	if ( ! is_writeable('_altauth') )
		mkdir('_altauth');
	
	if ( isset($_REQUEST['do_login']) ) 
	{
		login();
		if($Message == '') {
			$Message = '<center><b>* '.__('authorization_failed').'</b></center>';	
		}
		
		include('altauth_loginscreen.php');
	}
	else if ( isset($_REQUEST['do_logout']) )
	{
		logout();
	}
	else if ( isset($_REQUEST['no_access']) )
	{
		if($_REQUEST['no_access'] == 1) {
			$Message = '<center><b>'.__('exceeded_ip').'</b></center>';	
		} else {
			$Message = __('not_authorized');
		}
		
		include('altauth_loginscreen.php');			
		
	}
	else if (! isset($_REQUEST['return_url']) || preg_match('/altauth.php$/', $_REQUEST['return_url']))
	{
		// initialize script if it's called directly
		init();
	}
	else
	{
		// display the login screen if called with a "return_url" parameter
		cleanup_session_dir();
		include('altauth_loginscreen.php');
	}
?>
