<?php
require_once('altauth_lib.php');
require_once('altauth_language.php');
require_once('YouTubeFramework/Controller.php');

$controller = new Controller();
$loadLayers = false;

// process the request according to the action
if (isset($_GET['action'])) {
    if (isset($_POST['form_action'])) {
        $action = $_POST['form_action'];
    } else {
        $action = $_GET['action'];
    }
} else {
    $action = 'list';
}

switch ($action) {
    case 'add':
        $title = __('add_a_video');
        $video['title'] = "";
        $video['yt-id'] = "";
        $video['toggle-controls'] = "on";
        $video['overlay_type'] = array();
    break;

    case 'edit':
        $title = __('edit_video');
        $id = $_GET['video'];
        $video = $controller->loadVideo($id);
        $loadLayers = true;
    break;

    case 'save':
        $message = '';
        $id = $_POST['yt_id'];
        
        if ($_POST['new']) {
            $title = __('add_a_video');  // just in case we get an error and we have to show the Add form again

            // check if the video already exists
            if (!$controller->hasVideo($id)) {
                $controller->saveVideo($_POST);

                $title = __('edit_video');
                $action = 'edit';

                $video = $controller->loadVideo($id);
                $message = "<div class='alert alert-success' role='success'>" . __('video') . " " . $_POST['title'] . " " . __('added_to_database') . "</div>";
            
                header('location:altauth_admin.php?action=edit&video=' . $_POST['yt_id']);
            } else {
                $message = "<div class='alert alert-danger' role='success'>" . __('video_in_use') . "</div>";
                $action = 'add';
                $video = $_POST;
                $loadLayers = true;
            }
        } else {
            $title = __('edit_video');  // just in case we get an error and we have to show the Edit form again
            
            $controller->deleteVideo($id);
            $controller->saveVideo($_POST);
            $video = $controller->loadVideo($id);

            $message = "<div class='alert alert-success' role='alert'>" . __('video') . " " . $_POST['title'] . " " . __('has_been_saved') . "</div>";
            $action = 'edit';
            $loadLayers = true;
        }
    break;

    case 'delete':
        $title = __('delete_video');
        $id = $_GET['video'];
        $controller->deleteVideo($id);
        header("Location: altauth_admin.php");
    break;

    default:
        $title = __('videos');
        $action = 'list';
}


require_once('parts/admin_header.php');
?>


<h1 class="page-header">
<?php echo $title; ?>
</h1>

    <?php
    // Videos list (action = 'list')
    if ($action == 'list') :
        ?>
    <div class="table-responsive dataTable_wrapper">
        <form id="altauth_admin_videos" name="altauth_admin" method="post">
            <table class="table table-striped altauth-datatable">
                <thead>
                    <tr>
                        <th><?php echo __('title'); ?></th>
                        <th><?php echo __('actions'); ?></th>
                    </tr>
                </thead>
                <tbody>
    <?php
    $videos = $controller->loadVideos();

    foreach ($videos as $video) {
        ?>
                        <tr>
                            <td class="content">&nbsp;<?php echo $video['title'] ?></td>
                            <td class="content">
                                
                                <a href="altauth_admin.php?action=edit&video=<?php echo $video['yt_id']; ?>" class="action-icon">
                                    <span class="glyphicon glyphicon-pencil"></span>
                                </a>

                                <a href="#" class="action-icon" onClick="
                                        if (confirm('<?php echo __('confirm_remove_video'); ?> <?= $video['title'] ?>?'))
                                        {
                                            window.location = 'altauth_admin.php?action=delete&video=<?php echo $video['yt_id']; ?>';
                                        }">
                                    <span class="glyphicon glyphicon-trash"></span>
                                </a>
                            </td>
                        </tr>
                                   <?php
                               }
                               ?>
                </tbody>
            </table>
        </form>
    </div>
                    <?php
                endif; 

                /* Add/Edit Video form (action = 'add' or 'edit') */
                if ($action == 'add' || $action == 'edit') :
                    if (isset($message) && $message != '')
                        echo $message;
                    ?>
<form id="altauth_save_page" name="altauth_save_video" method="post" class="form-horizontal" role="form" autocomplete="off">
        <input type="hidden" id="new" name="new" value="<?php echo ($action == 'add') ? 1 : 0; ?>">
        <div class="form-group">
            <label class="control-label col-sm-2" for="title"><?php echo __('title'); ?>:</label>
            <div class="col-sm-10">
                <input type="text" class="form-control" id="title" name="title" placeholder="<?php echo __('title'); ?>" required value="<?php echo $video['title']; ?>">
            </div>
        </div>

        <div class="form-group">
            <label class="control-label col-sm-2" for="yt_id"><?php echo __('yt_id'); ?>:</label>
            <div class="col-sm-10">
                <input type="text" class="form-control" id="yt_id" name="yt_id" placeholder="<?php echo __('yt_id_tip'); ?>" required value="<?php echo $video['yt_id']; ?>">
            </div>
        </div>

        <div class="form-group row">
            <div class="col-md-10">
                <div class="embedding">
                    <iframe id="ttl-video" width="100" height="100" src="https://www.youtube.com/embed/" frameborder="0" class="video-wrapper"></iframe>

                    <div class="overlay-wrapper">
                        <div class="overlay"></div>
                    </div>
                </div>
            </div>

            <div class="col-md-2 text-right controls-div">
                <p><i><?php echo __('reload_after_switching') ?></i></p>

                <p><b><?php echo __('show_controls') ?></b></p>
                <input type="checkbox" name="toggle-controls" <?php if($video['toggle-controls'] === 'on') echo 'checked' ?>>
            
                <p><b><?php echo __('autoplay') ?></b></p>
                <input type="checkbox" name="autoplay" <?php if($video['autoplay'] === 'on') echo 'checked' ?>>
            </div>
        </div>

        <div class="form-group">
            <label class="control-label col-sm-2" for="add"><?php echo __('add_overlay'); ?>:</label>
            <div class="col-sm-10">
                <div class="row">
                    <div class="col-sm-10">
                        <select name="overlay_type_loader" class="form-control">
                            <option value="banner"><?php echo __('banner'); ?></option>
                            <option value="social_action"><?php echo __('social_action'); ?></option>
                            <option value="custom_html"><?php echo __('custom_html'); ?></option>
                            <option value="sub_form"><?php echo __('sub_form'); ?></option>
                            <option value="selling_url"><?php echo __('selling_url'); ?></option>
                            <option value="effect"><?php echo __('effect'); ?></option>
                        </select>
                    </div>

                    <div class="col-sm-2">
                        <button type="button" class="btn btn-default" name="add_overlay" value="add"><?php echo __('add'); ?></button>
                    </div>
                </div>
            </div>
        </div>

        <div class="panel-group" id="overlays" role="tablist" aria-multiselectable="true">
            <?php if(count($video['overlay_type']) > 0) :
                    foreach($video['overlay_type'] as $key => $value) {
                    if($value !== 'startScreen' && $value !== 'endScreen' && $value !== 'customThumb') :
                        $panelTime = str_replace('.', '', uniqid('p', true)) ?>
                            <div class="panel panel-default">
                                <div class="panel-heading" role="tab" id="overlay-title-<?php echo $panelTime ?>">
                                    <h4 class="panel-title"><a role="button" data-toggle="collapse" data-parent="#overlays" href="#overlay-<?php echo $panelTime ?>" aria-controls="overlay-<?php echo $panelTime ?>"><?php echo __($value) ?></a></h4>
                                </div>
                                <div id="overlay-<?php echo $panelTime ?>" class="panel-collapse collapse" role="tabpanel" aria-labelledby="overlay-title-<?php echo $panelTime ?>">
                                    <div class="panel-body">
                                        <?php if($value === 'banner') { 
                                                $params = array(
                                                    'banner_url' => $video['banner_url'][$key],
                                                    'banner_link' => $video['banner_link'][$key],
                                                    'start_at' => $video['start_at'][$key],
                                                    'start_at_type' => $video['start_at_type'][$key],
                                                    'stop_at' => $video['stop_at'][$key],
                                                    'stop_at_type' => $video['stop_at_type'][$key],
                                                    'v_position' => $video['v_position'][$key],
                                                    'h_position' => $video['h_position'][$key],
                                                    'pause_video' => $video['pause_video'][$key]);

                                                $controller->renderTemplate('banner', $params); ?>
                                        <?php } ?>
                                        <?php if($value === 'socialAction') { 
                                                $params = array(
                                                    'social_action' => $video['social_action'][$key],
                                                    'share_link' => $video['share_link'][$key],
                                                    'facebook_like' => $video['facebook_like'][$key],
                                                    'twitter_follow' => $video['twitter_follow'][$key],
                                                    'gplus_follow' => $video['gplus_follow'][$key],
                                                    'linkedin_follow' => $video['linkedin_follow'][$key],
                                                    'pinterest_follow' => $video['pinterest_follow'][$key],
                                                    'start_at' => $video['start_at'][$key],
                                                    'start_at_type' => $video['start_at_type'][$key],
                                                    'stop_at' => $video['stop_at'][$key],
                                                    'stop_at_type' => $video['stop_at_type'][$key],
                                                    'v_position' => $video['v_position'][$key],
                                                    'h_position' => $video['h_position'][$key],
                                                    'social_text' => $video['social_text'][$key],
                                                    'pause_video' => $video['pause_video'][$key]);

                                                $controller->renderTemplate('social_action', $params); ?>
                                        <?php } ?>
                                        <?php if($value === 'customHtml') { 
                                                $params = array(
                                                    'custom_html' => $video['custom_html'][$key],
                                                    'start_at' => $video['start_at'][$key],
                                                    'start_at_type' => $video['start_at_type'][$key],
                                                    'stop_at' => $video['stop_at'][$key],
                                                    'stop_at_type' => $video['stop_at_type'][$key],
                                                    'activate_mce' => 'edit');

                                                $controller->renderTemplate('custom_html', $params); ?>
                                        <?php } ?>
                                        <?php if($value === 'subscriptionForm') { 
                                                $params = array(
                                                    'template_name' => $video['template_name'][$key],
                                                    'aweber_lists' => $video['aweber_lists'][$key],
                                                    'start_at' => $video['start_at'][$key],
                                                    'start_at_type' => $video['start_at_type'][$key],
                                                    'headline_msg' => $video['headline_msg'][$key],
                                                    'subheadline_msg' => $video['subheadline_msg'][$key],
                                                    'thank_you_message' => $video['thank_you_message'][$key]);

                                                $controller->renderTemplate('sub_form', $params); ?>
                                        <?php } ?>
                                        <?php if($value === 'sellingUrl') { 
                                                $params = array(
                                                    'sale_service' => $video['sale_service'][$key],
                                                    'clickbank_products' => $video['clickbank_products'][$key],
                                                    'jvzoo_product_link' => $video['jvzoo_product_link'][$key],
                                                    'jvzoo_product_banner' => $video['jvzoo_product_banner'][$key],
                                                    'start_at' => $video['start_at'][$key],
                                                    'start_at_type' => $video['start_at_type'][$key],
                                                    'v_position' => $video['v_position'][$key],
                                                    'h_position' => $video['h_position'][$key],
                                                    'product_text' => $video['product_text'][$key]);

                                                $controller->renderTemplate('selling_url', $params); ?>
                                        <?php } ?>
                                        <?php if($value === 'effect') {
                                            $params = array(
                                                'effect_name' => $video['effect_name'][$key],
                                                'start_at' => $video['start_at'][$key],
                                                'start_at_type' => $video['start_at_type'][$key],
                                                'duration' => $video['duration'][$key],
                                                'duration_type' => $video['duration_type'][$key],
                                                'pause_video' => $video['pause_video'][$key],
                                                'skip_effect' => $video['skip_effect'][$key],
                                                'skip_effect_at' => $video['skip_effect_at'][$key],
                                                'skip_effect_at_type' => $video['skip_effect_at_type'][$key]
                                            );

                                            $controller->renderTemplate('effect', $params); ?>
                                        <?php } ?>
                                    </div>
                                </div>  
                            </div> 
                        <?php endif ?>
                <?php } ?>
            <?php endif ?>
        </div>
        
        <fieldset>
            <legend><?php echo __('start_screen') ?></legend>
            <div class="form-group">
                <label class="control-label col-sm-2" for="use_start_screen"><?php echo __('use_start_screen') ?></label>
                <div class="col-sm-10">
                    <input type="checkbox" name="use_start_screen" <?php if ($video['use_start_screen'] === 'on' && $video['serialized_layer']['start'] !== '') echo 'checked' ?>>
                </div>
            </div>
            
            <div data-start-form>
                <?php 
                    if($video['use_start_screen'] == 'on' && $video['serialized_layer']['start'] !== '') {
                        $params = array(
                            'image_url' => $video['image_url']['start'],
                            'use_actual_size' => isset($video['use_actual_size']['start']),
                            'width' => $video['width']['start'],
                            'height' => $video['height']['start'],
                            'stop_at' => $video['stop_at']['start'],
                            'stop_at_type' => $video['stop_at_type']['start']);
                
                        $controller->renderTemplate('start_screen', $params);
                    } ?>
            </div>
        </fieldset>
            
        <fieldset>
            <legend><?php echo __('end_screen') ?></legend>
            <div class="form-group">
                <label class="control-label col-sm-2" for="use_end_screen"><?php echo __('use_end_screen') ?></label>
                <div class="col-sm-10">
                    <input type="checkbox" name="use_end_screen" <?php if ($video['use_end_screen'] === 'on' && $video['serialized_layer']['end'] !== '') echo 'checked' ?>>
                </div>
            </div>
            
            <div data-end-form>
                <?php 
                    if($video['use_end_screen'] == 'on' && $video['serialized_layer']['end'] !== '') {
                        $params = array(
                            'image_url' => $video['image_url']['end'],
                            'use_actual_size' => isset($video['use_actual_size']['end']),
                            'width' => $video['width']['end'],
                            'height' => $video['height']['end'],
                            'stop_at' => $video['stop_at']['end'],
                            'stop_at_type' => $video['stop_at_type']['end']);
                
                        $controller->renderTemplate('end_screen', $params);
                    } ?>
            </div>
        </fieldset>
        
        <fieldset>
            <legend><?php echo __('custom_thumbnail') ?></legend>
            <div class="form-group">
                <label class="control-label col-sm-2" for="use_custom_thumbnail"><?php echo __('use_custom_thumbnail') ?></label>
                <div class="col-sm-10">
                    <input type="checkbox" name="use_custom_thumbnail" <?php if ($video['use_custom_thumbnail'] === 'on' && $video['serialized_layer']['custom_thumbnail'] !== '') echo 'checked' ?>>
                </div>
            </div>
            
            <div data-custthumb-form>
                <?php 
                    if($video['use_custom_thumbnail'] == 'on' && $video['serialized_layer']['custom_thumbnail'] !== '') {
                        $params = array('image_url' => $video['image_url']['custom_thumbnail']);
                
                        $controller->renderTemplate('custom_thumbnail', $params);
                    } ?>
            </div>
        </fieldset>
        <?php 
            //If edit, initialize layers and TinyMCE
            if($loadLayers) { ?> 
                <script>
                    jQuery(document).ready(function() {
                        var interval = setInterval(function() {
                            if(TVE.isReady() && TVE.getVideoById('<?php echo $video['yt_id'] ?>') != null) {
                                clearInterval(interval);

                                var layers = jQuery('[data-overlay-id]');

                                if(layers.length > 0)
                                    jQuery.each(layers, function(i, val) {
                                        jQuery(this).trigger('click');
                                    });
                            }
                        }, 200);
                        
                        var tinyMces = jQuery('.tinymce-box');
                        
                        if(tinyMces.length > 0)
                            jQuery.each(tinyMces, function(i, val) {
                                tinymce.init({
                                    height: 300,
                                    selector: "#" + jQuery(this).attr('id'), 
                                    extended_valid_elements: "script[charset|defer|language|src|type]",
                                    menubar: "edit insert format table tools", 
                                    toolbar: 'fontselect fontsizeselect forecolor backcolor | styleselect | bold italic | alignleft aligncenter alignright alignjustify | bullist numlist outdent indent | link image media table | preview code fullpage | undo redo',
                                    plugins: [
                                        'advlist autolink link image lists charmap print preview hr anchor pagebreak spellchecker',
                                        'searchreplace wordcount visualblocks visualchars code fullscreen insertdatetime media nonbreaking',
                                        'save table contextmenu directionality template paste textcolor'
                                    ],
                                    content_css: "https://maxcdn.bootstrapcdn.com/bootstrap/3.3.6/css/bootstrap.min.css",
                                    resize: false
                                }); 
                            });
                    });
                </script>
            <?php } ?>
                
        <hr />
        
        <?php if($action === 'edit') : ?>
            <div class="panel-group" id="embed-options" role="tablist" aria-multiselectable="false">
                <div class="panel panel-default">
                    <div class="panel-heading" role="tab" id="embed-dropdown-title">
                        <h4 class="panel-title"><a role="button" data-toggle="collapse" data-parent="#embed-options" href="#embed-dropdown" aria-controls="embed-dropdown"><?php echo __('embed_video') ?></a></h4>
                    </div>
                    <div id="embed-dropdown" class="panel-collapse collapse" role="tabpanel" aria-labelledby="embed-dropdown-title">
                        <div class="panel-body">
                            <div class="form-group">
                                <div class="col-sm-6">
                                    <div class="input-group">
                                        <input class="form-control" id="iframe_width" name="iframe_width" placeholder="<?php echo __('width') ?>" maxlength="4" value="1280" type="text" />
                                        <div class="input-group-addon">px</div>
                                    </div>
                                </div>

                                <div class="col-sm-6">
                                    <div class="input-group">
                                        <input class="form-control" id="iframe_height" name="iframe_height" placeholder="<?php echo __('height') ?>" maxlength="4" value="720" type="text" />
                                        <div class="input-group-addon">px</div>
                                    </div>
                                </div>
                            </div>
                            
                            <div class="form-group">
                                <div class="col-sm-12">
                                    <?php $urlManager = new UrlManager() ?>
                                    <input type="text" class="form-control" name="iframe_code" readonly value="<?php echo htmlentities('<iframe width="1280" height="720" src="' . $urlManager->getUrlWithoutScript($_SERVER) . '/embed.php?v=' . md5($video['yt_id']) . '" frameborder="0"></iframe>') ?>" />
                                    <?php unset($urlManager) ?>
                                </div>
                            </div>
                        </div>  
                    </div>  
                </div>
            </div>
        <?php endif ?>

        <div class="form-group"> 
            <div class="col-sm-12 text-right">
                <button type="submit" class="btn btn-primary" name="form_action" value="save"><?php echo __('save'); ?></button>
                <input type="hidden" name="form_action" value="save" />
            </div>
        </div>
    </form>

    <?php
endif;  // end of Add/Edit user form
?>

<?php
require_once('parts/admin_footer.php');
unset($controller);
?>