<?php
  require_once('altauth_lib.php');
  require_once('altauth_language.php');

  $config = array();
  $config_keys = array('adminemail');
  
  // load config values
  foreach ($config_keys as $key)
  {
    if (file_exists("altauth_$key.txt"))
      $config[$key] = trim(join('', file("altauth_$key.txt")));
  }

  if(isset($_POST['do_set_config'])) {
    // change admin user
    $admin_user = (isset($_POST['adminemail']) && trim($_POST['adminemail'] != '')) ? $_POST['adminemail'] : 'admin';

    // change admin password
    if(isset($_POST['pwd']) && $_POST['pwd'] != '') {
      $_COOKIE['altauth_user'] = $admin_user;
      setcookie("altauth_user", $admin_user);
      save_user($admin_user, $_POST['pwd'], true);
    }

    foreach($config_keys as $key)  {
      $file = "altauth_$key.txt";
      $param = trim($_REQUEST[$key]);
      
      if (isset($config[$key]) && $param == $config[$key])
        continue;
      
      if ( $param ) {
        $fh = fopen($file, 'w')
          or die(__('fail_create_file')." $file");
        fwrite($fh, $param);
        fclose($fh);
        
        $config[$key] = $param;
      } else {
        if (file_exists($file))
          unlink($file);
        
        $config[$key] = '';
      }
    }

    $message = "<div class='alert alert-success' role='success'>".__('settings_saved')."</div>";      
  }



  require_once('parts/admin_header.php');
?>

  <h1 class="page-header">
        <?php echo __('admin_settings'); ?>
  </h1>
  <?php if(isset($message) && $message != '') echo $message; ?>
  <form class="form-horizontal" method=post name="ConfigForm" role="form">
    <div class="form-group">
      <label class="control-label col-sm-3" for="adminemail"><?php echo __('email'); ?>:</label>
      <div class="col-sm-4">
        <input type="email" class="form-control" id="adminemail" name="adminemail" placeholder="<?php echo __('enter_email'); ?>" value="<?php echo isset($config['adminemail']) ? $config['adminemail'] : ''?>">
      </div>
    </div>

    <div class="form-group">
      <label class="control-label col-sm-3" for="pwd"><?php echo __('password'); ?>:</label>
      <div class="col-sm-4"> 
        <input type="password" class="form-control" id="pwd" name="pwd" placeholder="<?php echo __('enter_password'); ?>">
      </div>
    </div>
  
    <div class="form-group"> 
      <div class="col-sm-offset-3 col-sm-9">
        <button type="submit" name="do_set_config" class="btn btn-default" value="Set"><?php echo __('save'); ?></button>
      </div>
    </div>
  </form>


<?php
  require_once('parts/admin_footer.php');
?>