<?php
require_once('altauth_language.php');

if (file_exists('parts/default_login_header.php')) {
    $header = file_get_contents('parts/default_login_header.php');
    $header = preg_replace('/%%title%%/', __('authentication'), $header);
    echo $header;
};

$resetpass_file = 'altauth_resetpassurl.txt';
$resetpass_url = file_exists($resetpass_file) ? preg_replace('/\\s+/', '', join('', file($resetpass_file))) : '';
?>

<form name="LoginForm" method=post action="altauth.php?do_login">
    <input type=hidden name="return_url" value="<?= $_REQUEST['return_url'] ?>">
    <div class="login-container">
        <div class="row">
            <div class="col-md-4 col-md-offset-4">
                <div class="panel panel-default ">
                    <div class="panel-heading">
                        <h2 class="panel-title"><?php echo __('please_sign_in'); ?></h2>
                    </div>
                    <div class="panel-body">
                        <form class="form-signin">
                            <input type="text" id="username" class="form-control" tabIndex="1" size="20" maxsize="30" name="username" placeholder="<?php echo __('email_address'); ?>" required autofocus value="<?= isset($_REQUEST['username']) ? $_REQUEST['username'] : '' ?>">
                            <input type="password" id="password" class="form-control" placeholder="<?php echo __('password'); ?>" required tabIndex="2" size="20" maxsize="30" name="password" value="">
                            <input type="checkbox" tabIndex="3" name="longlife" <?= isset($_REQUEST['longlife']) ? 'checked' : '' ?> value="1"> <?php echo __('remember_me'); ?>

                            <button class="btn btn-primary btn-block" type="submit" name="do_login"><?php echo __('sign_in'); ?></button>

                            <?php if ($resetpass_url) : ?> 
                                <label>
                                    <a href="#" onClick="document.location = '<?= $resetpass_url ?>?username=' + escape(document.forms['LoginForm'].username.value) + '&return_url=' + escape(document.forms['LoginForm'].return_url.value); return false"><?php echo __('forgot_password'); ?></a>
                                </label>
                            <?php endif; ?>   
                        </form>
                    </div>
                </div>	
                <?php if (isset($Message)) : ?>
                    <div class="alert alert-danger" role="alert"><?php echo $Message; ?></div>			
                <?php endif; ?>
            </div>
        </div>
    </div>
</form>


<script>
    document.forms['LoginForm'].username.focus();
</script>

<?php
if (file_exists('parts/default_login_footer.php')) {
    $footer = file_get_contents('parts/default_login_footer.php');
    echo $footer;
};
?>
